/*
 *  BarCode Coder Library (BCC Library)
 *  BCCL Version 2.0
 *    
 *  Porting : Prototype barcode plugin 
 *  Version : 2.0.2
 *   
 *  Date  : March 01, 2011
 *  Author  : DEMONTE Jean-Baptiste <jbdemonte@gmail.com>
 *            HOUREZ Jonathan
 * 
 *  Web site: http://barcode-coder.com/
 *  dual licence :  http://www.cecill.info/licences/Licence_CeCILL_V2-fr.html
 *                  http://www.gnu.org/licenses/gpl.html
 */
var Barcode={settings:{barWidth:1,barHeight:50,moduleSize:5,showHRI:true,addQuietZone:true,marginHRI:5,bgColor:"#FFFFFF",color:"#000000",fontSize:10,output:"css",posX:0,posY:0},intval:function(b){var a=typeof(b);if(a=="string"){b=b.replace(/[^0-9-.]/g,"");b=parseInt(b*1,10);return isNaN(b)||!isFinite(b)?0:b}return a=="number"&&isFinite(b)?Math.floor(b):0},i25:{encoding:["NNWWN","WNNNW","NWNNW","WWNNN","NNWNW","WNWNN","NWWNN","NNNWW","WNNWN","NWNWN"],compute:function(e,g,d){if(!g){if(e.length%2!=0){e="0"+e}}else{if((d=="int25")&&(e.length%2==0)){e="0"+e}var f=true,a,c=0;for(var b=e.length-1;b>-1;b--){a=Barcode.intval(e.charAt(b));if(isNaN(a)){return("")}c+=f?3*a:a;f=!f}e+=((10-c%10)%10).toString()}return(e)},getDigit:function(g,h,f){g=this.compute(g,h,f);if(g==""){return("")}result="";var d,a;if(f=="int25"){result+="1010";var e,b;for(d=0;d<g.length/2;d++){e=g.charAt(2*d);b=g.charAt(2*d+1);for(a=0;a<5;a++){result+="1";if(this.encoding[e].charAt(a)=="W"){result+="1"}result+="0";if(this.encoding[b].charAt(a)=="W"){result+="0"}}}result+="1101"}else{if(f=="std25"){result+="11011010";var k;for(d=0;d<g.length;d++){k=g.charAt(d);for(a=0;a<5;a++){result+="1";if(this.encoding[k].charAt(a)=="W"){result+="11"}result+="0"}}result+="11010110"}}return(result)}},ean:{encoding:[["0001101","0100111","1110010"],["0011001","0110011","1100110"],["0010011","0011011","1101100"],["0111101","0100001","1000010"],["0100011","0011101","1011100"],["0110001","0111001","1001110"],["0101111","0000101","1010000"],["0111011","0010001","1000100"],["0110111","0001001","1001000"],["0001011","0010111","1110100"]],first:["000000","001011","001101","001110","010011","011001","011100","010101","010110","011010"],getDigit:function(f,e){var a=e=="ean8"?7:12;f=f.substring(0,a);if(f.length!=a){return("")}var h;for(var d=0;d<f.length;d++){h=f.charAt(d);if((h<"0")||(h>"9")){return("")}}f=this.compute(f,e);var g="101";if(e=="ean8"){for(var d=0;d<4;d++){g+=this.encoding[Barcode.intval(f.charAt(d))][0]}g+="01010";for(var d=4;d<8;d++){g+=this.encoding[Barcode.intval(f.charAt(d))][2]}}else{var b=this.first[Barcode.intval(f.charAt(0))];for(var d=1;d<7;d++){g+=this.encoding[Barcode.intval(f.charAt(d))][Barcode.intval(b.charAt(d-1))]}g+="01010";for(var d=7;d<13;d++){g+=this.encoding[Barcode.intval(f.charAt(d))][2]}}g+="101";return(g)},compute:function(d,c){var a=c=="ean13"?12:7;d=d.substring(0,a);var b=0,e=true;for(i=d.length-1;i>-1;i--){b+=(e?3:1)*Barcode.intval(d.charAt(i));e=!e}return(d+((10-b%10)%10).toString())}},msi:{encoding:["100100100100","100100100110","100100110100","100100110110","100110100100","100110100110","100110110100","100110110110","110100100100","110100100110"],compute:function(a,b){if(typeof(b)=="object"){if(b.crc1=="mod10"){a=this.computeMod10(a)}else{if(b.crc1=="mod11"){a=this.computeMod11(a)}}if(b.crc2=="mod10"){a=this.computeMod10(a)}else{if(b.crc2=="mod11"){a=this.computeMod11(a)}}}else{if(typeof(b)=="boolean"){if(b){a=this.computeMod10(a)}}}return(a)},computeMod10:function(f){var b,e=f.length%2;var d=0,c=0;for(b=0;b<f.length;b++){if(e){d=10*d+Barcode.intval(f.charAt(b))}else{c+=Barcode.intval(f.charAt(b))}e=!e}var a=(2*d).toString();for(b=0;b<a.length;b++){c+=Barcode.intval(a.charAt(b))}return(f+((10-c%10)%10).toString())},computeMod11:function(d){var c=0,a=2;for(var b=d.length-1;b>=0;b--){c+=a*Barcode.intval(d.charAt(b));a=a==7?2:a+1}return(d+((11-c%11)%11).toString())},getDigit:function(c,e){var b="0123456789";var a=0;var d="";c=this.compute(c,false);d="110";for(i=0;i<c.length;i++){a=b.indexOf(c.charAt(i));if(a<0){return("")}d+=this.encoding[a]}d+="1001";return(d)}},code11:{encoding:["101011","1101011","1001011","1100101","1011011","1101101","1001101","1010011","1101001","110101","101101"],getDigit:function(a){var o="0123456789-";var e,h,m="",f="0";m="1011001"+f;for(e=0;e<a.length;e++){h=o.indexOf(a.charAt(e));if(h<0){return("")}m+=this.encoding[h]+f}var n=0,b=0,g=1,j=0;for(e=a.length-1;e>=0;e--){n=n==10?1:n+1;g=g==10?1:g+1;h=o.indexOf(a.charAt(e));b+=n*h;j+=g*h}var l=b%11;j+=l;var d=j%11;m+=this.encoding[l]+f;if(a.length>=10){m+=this.encoding[d]+f}m+="1011001";return(m)}},code39:{encoding:["101001101101","110100101011","101100101011","110110010101","101001101011","110100110101","101100110101","101001011011","110100101101","101100101101","110101001011","101101001011","110110100101","101011001011","110101100101","101101100101","101010011011","110101001101","101101001101","101011001101","110101010011","101101010011","110110101001","101011010011","110101101001","101101101001","101010110011","110101011001","101101011001","101011011001","110010101011","100110101011","110011010101","100101101011","110010110101","100110110101","100101011011","110010101101","100110101101","100100100101","100100101001","100101001001","101001001001","100101101101"],getDigit:function(d){var c="0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ-. $/+%*";var b,a,f="",e="0";if(d.indexOf("*")>=0){return("")}d=("*"+d+"*").toUpperCase();for(b=0;b<d.length;b++){a=c.indexOf(d.charAt(b));if(a<0){return("")}if(b>0){f+=e}f+=this.encoding[a]}return(f)}},code93:{encoding:["100010100","101001000","101000100","101000010","100101000","100100100","100100010","101010000","100010010","100001010","110101000","110100100","110100010","110010100","110010010","110001010","101101000","101100100","101100010","100110100","100011010","101011000","101001100","101000110","100101100","100010110","110110100","110110010","110101100","110100110","110010110","110011010","101101100","101100110","100110110","100111010","100101110","111010100","111010010","111001010","101101110","101110110","110101110","100100110","111011010","111010110","100110010","101011110"],getDigit:function(a,f){var m="0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ-. $/+%____*",h,j="";if(a.indexOf("*")>=0){return("")}a=a.toUpperCase();j+=this.encoding[47];for(i=0;i<a.length;i++){h=a.charAt(i);index=m.indexOf(h);if((h=="_")||(index<0)){return("")}j+=this.encoding[index]}if(f){var l=0,b=0,e=1,g=0;for(i=a.length-1;i>=0;i--){l=l==20?1:l+1;e=e==15?1:e+1;index=m.indexOf(a.charAt(i));b+=l*index;g+=e*index}var h=b%47;g+=h;var d=g%47;j+=this.encoding[h];j+=this.encoding[d]}j+=this.encoding[47];j+="1";return(j)}},code128:{encoding:["11011001100","11001101100","11001100110","10010011000","10010001100","10001001100","10011001000","10011000100","10001100100","11001001000","11001000100","11000100100","10110011100","10011011100","10011001110","10111001100","10011101100","10011100110","11001110010","11001011100","11001001110","11011100100","11001110100","11101101110","11101001100","11100101100","11100100110","11101100100","11100110100","11100110010","11011011000","11011000110","11000110110","10100011000","10001011000","10001000110","10110001000","10001101000","10001100010","11010001000","11000101000","11000100010","10110111000","10110001110","10001101110","10111011000","10111000110","10001110110","11101110110","11010001110","11000101110","11011101000","11011100010","11011101110","11101011000","11101000110","11100010110","11101101000","11101100010","11100011010","11101111010","11001000010","11110001010","10100110000","10100001100","10010110000","10010000110","10000101100","10000100110","10110010000","10110000100","10011010000","10011000010","10000110100","10000110010","11000010010","11001010000","11110111010","11000010100","10001111010","10100111100","10010111100","10010011110","10111100100","10011110100","10011110010","11110100100","11110010100","11110010010","11011011110","11011110110","11110110110","10101111000","10100011110","10001011110","10111101000","10111100010","11110101000","11110100010","10111011110","10111101110","11101011110","11110101110","11010000100","11010010000","11010011100","11000111010"],getDigit:function(a){var k=" !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~";var l="";var g=0;var b=0;var f=0;var e=0;var m=0;for(f=0;f<a.length;f++){if(k.indexOf(a.charAt(f))==-1){return("")}}var d=a.length>1;var h="";for(f=0;f<3&&f<a.length;f++){h=a.charAt(f);d&=h>="0"&&h<="9"}g=d?105:104;l=this.encoding[g];f=0;while(f<a.length){if(!d){e=0;while((f+e<a.length)&&(a.charAt(f+e)>="0")&&(a.charAt(f+e)<="9")){e++}d=(e>5)||((f+e-1==a.length)&&(e>3));if(d){l+=this.encoding[99];g+=++b*99}}else{if((f==a.length)||(a.charAt(f)<"0")||(a.charAt(f)>"9")||(a.charAt(f+1)<"0")||(a.charAt(f+1)>"9")){d=false;l+=this.encoding[100];g+=++b*100}}if(d){m=Barcode.intval(a.charAt(f)+a.charAt(f+1));f+=2}else{m=k.indexOf(a.charAt(f));f+=1}l+=this.encoding[m];g+=++b*m}l+=this.encoding[g%103];l+=this.encoding[106];l+="11";return(l)}},codabar:{encoding:["101010011","101011001","101001011","110010101","101101001","110101001","100101011","100101101","100110101","110100101","101001101","101100101","1101011011","1101101011","1101101101","1011011011","1011001001","1010010011","1001001011","1010011001"],getDigit:function(d){var c="0123456789-$:/.+";var b,a,f="",e="0";f+=this.encoding[16]+e;for(b=0;b<d.length;b++){a=c.indexOf(d.charAt(b));if(a<0){return("")}f+=this.encoding[a]+e}f+=this.encoding[16];return(f)}},datamatrix:{encoding:["101010011","101011001","101001011","110010101","101101001","110101001","100101011","100101101","100110101","110100101","101001101","101100101","1101011011","1101101011","1101101101","1011011011","1011001001","1010010011","1001001011","1010011001"],lengthRows:[10,12,14,16,18,20,22,24,26,32,36,40,44,48,52,64,72,80,88,96,104,120,132,144,8,8,12,12,16,16],lengthCols:[10,12,14,16,18,20,22,24,26,32,36,40,44,48,52,64,72,80,88,96,104,120,132,144,18,32,26,36,36,48],mappingRows:[8,10,12,14,16,18,20,22,24,28,32,36,40,44,48,56,64,72,80,88,96,108,120,132,6,6,10,10,14,14],mappingCols:[8,10,12,14,16,18,20,22,24,28,32,36,40,44,48,56,64,72,80,88,96,108,120,132,16,28,24,32,32,44],dataCWCount:[3,5,8,12,18,22,30,36,44,62,86,114,144,174,204,280,368,456,576,696,816,1050,1304,1558,5,10,16,22,32,49],solomonCWCount:[5,7,10,12,14,18,20,24,28,36,42,48,56,68,84,112,144,192,224,272,336,408,496,620,7,11,14,18,24,28],dataRegionRows:[8,10,12,14,16,18,20,22,24,14,16,18,20,22,24,14,16,18,20,22,24,18,20,22,6,6,10,10,14,14],dataRegionCols:[8,10,12,14,16,18,20,22,24,14,16,18,20,22,24,14,16,18,20,22,24,18,20,22,16,14,24,16,16,22],regionRows:[1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,4,4,4,4,4,4,6,6,6,1,1,1,1,1,1],regionCols:[1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,4,4,4,4,4,4,6,6,6,1,2,1,2,2,2],interleavedBlocks:[1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,4,4,4,4,6,6,8,8,1,1,1,1,1,1],logTab:[-255,255,1,240,2,225,241,53,3,38,226,133,242,43,54,210,4,195,39,114,227,106,134,28,243,140,44,23,55,118,211,234,5,219,196,96,40,222,115,103,228,78,107,125,135,8,29,162,244,186,141,180,45,99,24,49,56,13,119,153,212,199,235,91,6,76,220,217,197,11,97,184,41,36,223,253,116,138,104,193,229,86,79,171,108,165,126,145,136,34,9,74,30,32,163,84,245,173,187,204,142,81,181,190,46,88,100,159,25,231,50,207,57,147,14,67,120,128,154,248,213,167,200,63,236,110,92,176,7,161,77,124,221,102,218,95,198,90,12,152,98,48,185,179,42,209,37,132,224,52,254,239,117,233,139,22,105,27,194,113,230,206,87,158,80,189,172,203,109,175,166,62,127,247,146,66,137,192,35,252,10,183,75,216,31,83,33,73,164,144,85,170,246,65,174,61,188,202,205,157,143,169,82,72,182,215,191,251,47,178,89,151,101,94,160,123,26,112,232,21,51,238,208,131,58,69,148,18,15,16,68,17,121,149,129,19,155,59,249,70,214,250,168,71,201,156,64,60,237,130,111,20,93,122,177,150],aLogTab:[1,2,4,8,16,32,64,128,45,90,180,69,138,57,114,228,229,231,227,235,251,219,155,27,54,108,216,157,23,46,92,184,93,186,89,178,73,146,9,18,36,72,144,13,26,52,104,208,141,55,110,220,149,7,14,28,56,112,224,237,247,195,171,123,246,193,175,115,230,225,239,243,203,187,91,182,65,130,41,82,164,101,202,185,95,190,81,162,105,210,137,63,126,252,213,135,35,70,140,53,106,212,133,39,78,156,21,42,84,168,125,250,217,159,19,38,76,152,29,58,116,232,253,215,131,43,86,172,117,234,249,223,147,11,22,44,88,176,77,154,25,50,100,200,189,87,174,113,226,233,255,211,139,59,118,236,245,199,163,107,214,129,47,94,188,85,170,121,242,201,191,83,166,97,194,169,127,254,209,143,51,102,204,181,71,142,49,98,196,165,103,206,177,79,158,17,34,68,136,61,122,244,197,167,99,198,161,111,222,145,15,30,60,120,240,205,183,67,134,33,66,132,37,74,148,5,10,20,40,80,160,109,218,153,31,62,124,248,221,151,3,6,12,24,48,96,192,173,119,238,241,207,179,75,150,1],champGaloisMult:function(d,c){if(!d||!c){return 0}return this.aLogTab[(this.logTab[d]+this.logTab[c])%255]},champGaloisDoub:function(d,c){if(!d){return 0}if(!c){return d}return this.aLogTab[(this.logTab[d]+c)%255]},champGaloisSum:function(d,c){return d^c},selectIndex:function(a,b){if((a<1||a>1558)&&!b){return -1}if((a<1||a>49)&&b){return -1}var c=0;if(b){c=24}while(this.dataCWCount[c]<a){c++}return c},encodeDataCodeWordsASCII:function(d){var b=new Array();var f=0,a,e;for(a=0;a<d.length;a++){e=d.charCodeAt(a);if(e>127){b[f]=235;e=e-127;f++}else{if((e>=48&&e<=57)&&(a+1<d.length)&&(d.charCodeAt(a+1)>=48&&d.charCodeAt(a+1)<=57)){e=((e-48)*10)+((d.charCodeAt(a+1))-48);e+=130;a++}else{e++}}b[f]=e;f++}return b},addPadCW:function(b,e,d){if(e>=d){return}b[e]=129;var c,a;for(a=e+1;a<d;a++){c=((149*(a+1))%253)+1;b[a]=(129+c)%254}},calculSolFactorTable:function(a){var d=new Array();var c,b;for(c=0;c<=a;c++){d[c]=1}for(c=1;c<=a;c++){for(b=c-1;b>=0;b--){d[b]=this.champGaloisDoub(d[b],c);if(b>0){d[b]=this.champGaloisSum(d[b],d[b-1])}}}return d},addReedSolomonCW:function(a,e,g,h,f){var m=0;var l=a/f;var n=new Array();var d,c,b;for(b=0;b<f;b++){for(d=0;d<l;d++){n[d]=0}for(d=b;d<g;d=d+f){m=this.champGaloisSum(h[d],n[l-1]);for(c=l-1;c>=0;c--){if(!m){n[c]=0}else{n[c]=this.champGaloisMult(m,e[c])}if(c>0){n[c]=this.champGaloisSum(n[c-1],n[c])}}}c=g+b;for(d=l-1;d>=0;d--){h[c]=n[d];c=c+f}}return h},getBits:function(b){var c=new Array();for(var a=0;a<8;a++){c[a]=b&(128>>a)?1:0}return c},next:function(f,h,b,g,e,a){var d=0;var j=4;var c=0;do{if((j==h)&&(c==0)){this.patternShapeSpecial1(e,a,g[d],h,b);d++}else{if((f<3)&&(j==h-2)&&(c==0)&&(b%4!=0)){this.patternShapeSpecial2(e,a,g[d],h,b);d++}else{if((j==h-2)&&(c==0)&&(b%8==4)){this.patternShapeSpecial3(e,a,g[d],h,b);d++}else{if((j==h+4)&&(c==2)&&(b%8==0)){this.patternShapeSpecial4(e,a,g[d],h,b);d++}}}}do{if((j<h)&&(c>=0)&&(a[j][c]!=1)){this.patternShapeStandard(e,a,g[d],j,c,h,b);d++}j-=2;c+=2}while((j>=0)&&(c<b));j+=1;c+=3;do{if((j>=0)&&(c<b)&&(a[j][c]!=1)){this.patternShapeStandard(e,a,g[d],j,c,h,b);d++}j+=2;c-=2}while((j<h)&&(c>=0));j+=3;c+=1}while((j<h)||(c<b))},patternShapeStandard:function(e,d,f,g,c,b,a){this.placeBitInDatamatrix(e,d,f[0],g-2,c-2,b,a);this.placeBitInDatamatrix(e,d,f[1],g-2,c-1,b,a);this.placeBitInDatamatrix(e,d,f[2],g-1,c-2,b,a);this.placeBitInDatamatrix(e,d,f[3],g-1,c-1,b,a);this.placeBitInDatamatrix(e,d,f[4],g-1,c,b,a);this.placeBitInDatamatrix(e,d,f[5],g,c-2,b,a);this.placeBitInDatamatrix(e,d,f[6],g,c-1,b,a);this.placeBitInDatamatrix(e,d,f[7],g,c,b,a)},patternShapeSpecial1:function(d,c,e,b,a){this.placeBitInDatamatrix(d,c,e[0],b-1,0,b,a);this.placeBitInDatamatrix(d,c,e[1],b-1,1,b,a);this.placeBitInDatamatrix(d,c,e[2],b-1,2,b,a);this.placeBitInDatamatrix(d,c,e[3],0,a-2,b,a);this.placeBitInDatamatrix(d,c,e[4],0,a-1,b,a);this.placeBitInDatamatrix(d,c,e[5],1,a-1,b,a);this.placeBitInDatamatrix(d,c,e[6],2,a-1,b,a);this.placeBitInDatamatrix(d,c,e[7],3,a-1,b,a)},patternShapeSpecial2:function(d,c,e,b,a){this.placeBitInDatamatrix(d,c,e[0],b-3,0,b,a);this.placeBitInDatamatrix(d,c,e[1],b-2,0,b,a);this.placeBitInDatamatrix(d,c,e[2],b-1,0,b,a);this.placeBitInDatamatrix(d,c,e[3],0,a-4,b,a);this.placeBitInDatamatrix(d,c,e[4],0,a-3,b,a);this.placeBitInDatamatrix(d,c,e[5],0,a-2,b,a);this.placeBitInDatamatrix(d,c,e[6],0,a-1,b,a);this.placeBitInDatamatrix(d,c,e[7],1,a-1,b,a)},patternShapeSpecial3:function(d,c,e,b,a){this.placeBitInDatamatrix(d,c,e[0],b-3,0,b,a);this.placeBitInDatamatrix(d,c,e[1],b-2,0,b,a);this.placeBitInDatamatrix(d,c,e[2],b-1,0,b,a);this.placeBitInDatamatrix(d,c,e[3],0,a-2,b,a);this.placeBitInDatamatrix(d,c,e[4],0,a-1,b,a);this.placeBitInDatamatrix(d,c,e[5],1,a-1,b,a);this.placeBitInDatamatrix(d,c,e[6],2,a-1,b,a);this.placeBitInDatamatrix(d,c,e[7],3,a-1,b,a)},patternShapeSpecial4:function(d,c,e,b,a){this.placeBitInDatamatrix(d,c,e[0],b-1,0,b,a);this.placeBitInDatamatrix(d,c,e[1],b-1,a-1,b,a);this.placeBitInDatamatrix(d,c,e[2],0,a-3,b,a);this.placeBitInDatamatrix(d,c,e[3],0,a-2,b,a);this.placeBitInDatamatrix(d,c,e[4],0,a-1,b,a);this.placeBitInDatamatrix(d,c,e[5],1,a-3,b,a);this.placeBitInDatamatrix(d,c,e[6],1,a-2,b,a);this.placeBitInDatamatrix(d,c,e[7],1,a-1,b,a)},placeBitInDatamatrix:function(e,d,g,f,c,b,a){if(f<0){f+=b;c+=4-((b+4)%8)}if(c<0){c+=a;f+=4-((a+4)%8)}if(d[f][c]!=1){e[f][c]=g;d[f][c]=1}},addFinderPattern:function(f,k,b,l,a){var h=(l+2)*k;var g=(a+2)*b;var c=new Array();c[0]=new Array();for(var d=0;d<g+2;d++){c[0][d]=0}for(var e=0;e<h;e++){c[e+1]=new Array();c[e+1][0]=0;c[e+1][g+1]=0;for(var d=0;d<g;d++){if(e%(l+2)==0){if(d%2==0){c[e+1][d+1]=1}else{c[e+1][d+1]=0}}else{if(e%(l+2)==l+1){c[e+1][d+1]=1}else{if(d%(a+2)==a+1){if(e%2==0){c[e+1][d+1]=0}else{c[e+1][d+1]=1}}else{if(d%(a+2)==0){c[e+1][d+1]=1}else{c[e+1][d+1]=0;c[e+1][d+1]=f[e-1-(2*(parseInt(e/(l+2))))][d-1-(2*(parseInt(d/(a+2))))]}}}}}}c[h+1]=new Array();for(var d=0;d<g+2;d++){c[h+1][d]=0}return c},getDigit:function(k,s){var q=this.encodeDataCodeWordsASCII(k);var c=q.length;var e=this.selectIndex(c,s);var l=this.dataCWCount[e];var v=this.solomonCWCount[e];var a=l+v;var y=this.lengthRows[e];var x=this.lengthCols[e];var h=this.regionRows[e];var j=this.regionCols[e];var d=this.dataRegionRows[e];var w=this.dataRegionCols[e];var u=y-2*h;var f=x-2*j;var n=this.interleavedBlocks[e];var o=(v/n);var b=(l/n);this.addPadCW(q,c,l);var t=this.calculSolFactorTable(o);this.addReedSolomonCW(v,t,l,q,n);var r=new Array();for(var p=0;p<a;p++){r[p]=this.getBits(q[p])}var z=new Array();var m=new Array();for(var p=0;p<f;p++){z[p]=new Array();m[p]=new Array()}if(((u*f)%8)==4){z[u-2][f-2]=1;z[u-1][f-1]=1;z[u-1][f-2]=0;z[u-2][f-1]=0;m[u-2][f-2]=1;m[u-1][f-1]=1;m[u-1][f-2]=1;m[u-2][f-1]=1}this.next(0,u,f,r,z,m);z=this.addFinderPattern(z,h,j,d,w);return z}},lec:{cInt:function(c,d){var b="";for(var a=0;a<d;a++){b+=String.fromCharCode(c&255);c=c>>8}return b},cRgb:function(d,c,a){return String.fromCharCode(a)+String.fromCharCode(c)+String.fromCharCode(d)},cHexColor:function(f){var c=parseInt("0x"+f.substr(1));var a=c&255;c=c>>8;var e=c&255;var d=c>>8;return(this.cRgb(d,e,a))}},hexToRGB:function(f){var c=parseInt("0x"+f.substr(1));var a=c&255;c=c>>8;var e=c&255;var d=c>>8;return({r:d,g:e,b:a})},isHexColor:function(b){var a=new RegExp("#[0-91-F]","gi");return b.match(a)},base64Encode:function(m){var a="",f,d,c,l,j,h,g;var b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";var e=0;while(e<m.length){f=m.charCodeAt(e++);d=m.charCodeAt(e++);c=m.charCodeAt(e++);l=f>>2;j=((f&3)<<4)|(d>>4);h=((d&15)<<2)|(c>>6);g=c&63;if(isNaN(d)){h=g=64}else{if(isNaN(c)){g=64}}a+=b.charAt(l)+b.charAt(j)+b.charAt(h)+b.charAt(g)}return a},bitStringTo2DArray:function(c){var b=[];b[0]=[];for(var a=0;a<c.length;a++){b[0][a]=c.charAt(a)}return(b)},resize:function(b,a){b.style.cssText+="padding: 0px; overflow: auto; width: "+a+"px";b.update("");return b},digitToBmpRenderer:function(r,u,m,e,l,v){var c=m.length;var d=m[0].length;var s=0;var p=this.isHexColor(u.bgColor)?this.lec.cHexColor(u.bgColor):this.lec.cRgb(255,255,255);var o=this.isHexColor(u.color)?this.lec.cHexColor(u.color):this.lec.cRgb(0,0,0);var b="";var a="";for(s=0;s<l;s++){b+=p;a+=o}var n="";var A=(4-((l*d*3)%4))%4;var z=(l*d+A)*v*c;var t="";for(s=0;s<A;s++){t+="\0"}var w="BM"+this.lec.cInt(54+z,4)+"\0\0\0\0"+this.lec.cInt(54,4)+this.lec.cInt(40,4)+this.lec.cInt(l*d,4)+this.lec.cInt(v*c,4)+this.lec.cInt(1,2)+this.lec.cInt(24,2)+"\0\0\0\0"+this.lec.cInt(z,4)+this.lec.cInt(2835,4)+this.lec.cInt(2835,4)+this.lec.cInt(0,4)+this.lec.cInt(0,4);for(var f=c-1;f>=0;f--){var h="";for(var g=0;g<d;g++){h+=m[f][g]=="0"?b:a}h+=t;for(var q=0;q<v;q++){w+=h}}var j=document.createElement("object");j.setAttribute("type","image/bmp");j.setAttribute("data","data:image/bmp;base64,"+this.base64Encode(w));this.resize(r,l*d+A).update(j)},digitToBmp:function(e,d,f,b){var a=Barcode.intval(d.barWidth);var c=Barcode.intval(d.barHeight);this.digitToBmpRenderer(e,d,this.bitStringTo2DArray(f),b,a,c)},digitToBmp2D:function(d,c,e,a){var b=Barcode.intval(c.moduleSize);this.digitToBmpRenderer(d,c,e,a,b,b)},digitToCssRenderer:function(o,b,k,c,n,e){var p=k.length;var a=k[0].length;var g="";var m='<div style="float: left; font-size: 0px; background-color: '+b.bgColor+"; height: "+e+'px; width: &Wpx"></div>';var j='<div style="float: left; font-size: 0px; width:0; border-left: &Wpx solid '+b.color+"; height: "+e+'px;"></div>';var d,f;for(var h=0;h<p;h++){d=0;f=k[h][0];for(var l=0;l<a;l++){if(f==k[h][l]){d++}else{g+=(f=="0"?m:j).replace("&W",d*n);f=k[h][l];d=1}}if(d>0){g+=(f=="0"?m:j).replace("&W",d*n)}}if(b.showHRI){g+='<div style="clear:both; width: 100%; background-color: '+b.bgColor+"; color: "+b.color+"; text-align: center; font-size: "+b.fontSize+"px; margin-top: "+b.marginHRI+'px;">'+c+"</div>"}this.resize(o,n*a).update(g)},digitToCss:function(e,d,f,b){var a=Barcode.intval(d.barWidth);var c=Barcode.intval(d.barHeight);this.digitToCssRenderer(e,d,this.bitStringTo2DArray(f),b,a,c)},digitToCss2D:function(d,c,e,a){var b=Barcode.intval(c.moduleSize);this.digitToCssRenderer(d,c,e,a,b,b)},digitToSvgRenderer:function(o,q,l,d,j,r){var b=l.length;var c=l[0].length;var m=j*c;var s=r*b;if(q.showHRI){var e=Barcode.intval(q.fontSize);s+=Barcode.intval(q.marginHRI)+e}var k='<svg xmlns="http://www.w3.org/2000/svg" version="1.1" width="'+m+'" height="'+s+'">';k+='<rect width="'+m+'" height="'+s+'" x="0" y="0" fill="'+q.bgColor+'" />';var a='<rect width="&W" height="'+r+'" x="&X" y="&Y" fill="'+q.color+'" />';var p,n;for(var f=0;f<b;f++){p=0;n=l[f][0];for(var g=0;g<c;g++){if(n==l[f][g]){p++}else{if(n=="1"){k+=a.replace("&W",p*j).replace("&X",(g-p)*j).replace("&Y",f*r)}n=l[f][g];p=1}}if((p>0)&&(n=="1")){k+=a.replace("&W",p*j).replace("&X",(c-p)*j).replace("&Y",f*r)}}if(q.showHRI){k+='<g transform="translate('+Math.floor(m/2)+' 0)">';k+='<text y="'+(s-Math.floor(e/2))+'" text-anchor="middle" style="font-family: Arial; font-size: '+e+'px;" fill="'+q.color+'">'+d+"</text>";k+="</g>"}k+="</svg>";var h=document.createElement("object");h.setAttribute("type","image/svg+xml");h.setAttribute("data","data:image/svg+xml,"+k);this.resize(o,m).update(h)},digitToSvg:function(e,d,f,b){var a=Barcode.intval(d.barWidth);var c=Barcode.intval(d.barHeight);this.digitToSvgRenderer(e,d,this.bitStringTo2DArray(f),b,a,c)},digitToSvg2D:function(d,c,e,a){var b=Barcode.intval(c.moduleSize);this.digitToSvgRenderer(d,c,e,a,b,b)},digitToCanvasRenderer:function(q,b,m,d,k,c,o,h){var g=q;if(!g||!g.getContext){return}var r=m.length;var a=m[0].length;var p=g.getContext("2d");p.lineWidth=1;p.lineCap="butt";p.fillStyle=b.bgColor;p.fillRect(k,c,a*o,r*h);p.fillStyle=b.color;for(var l=0;l<r;l++){var f=0;var j=m[l][0];for(var n=0;n<a;n++){if(j==m[l][n]){f++}else{if(j=="1"){p.fillRect(k+(n-f)*o,c+l*h,o*f,h)}j=m[l][n];f=1}}if((f>0)&&(j=="1")){p.fillRect(k+(a-f)*o,c+l*h,o*f,h)}}if(b.showHRI){var e=p.measureText(d);p.fillText(d,k+Math.floor((a*o-e.width)/2),c+r*h+b.fontSize+b.marginHRI)}},digitToCanvas:function(f,e,j,c){var b=Barcode.intval(e.barWidth);var d=Barcode.intval(e.barHeight);var a=Barcode.intval(e.posX);var g=Barcode.intval(e.posY);this.digitToCanvasRenderer(f,e,this.bitStringTo2DArray(j),c,a,g,b,d)},digitToCanvas2D:function(e,d,g,b){var c=Barcode.intval(d.moduleSize);var a=Barcode.intval(d.posX);var f=Barcode.intval(d.posY);this.digitToCanvasRenderer(e,d,g,b,a,f,c,c)}};var barcodeMethod={barcode:function(d,g,k,e){var l=$(d);var n="",f="",b="",j=true,m=false,h=false;if(typeof(g)=="string"){b=g}else{if(typeof(g)=="object"){b=typeof(g.code)=="string"?g.code:"";j=typeof(g.crc)!="undefined"?g.crc:true;m=typeof(g.rect)!="undefined"?g.rect:false}}if(b==""){return(false)}if(typeof(e)=="undefined"){e=[]}for(var a in Barcode.settings){if(e[a]==undefined){e[a]=Barcode.settings[a]}}switch(k){case"std25":case"int25":n=Barcode.i25.getDigit(b,j,k);f=Barcode.i25.compute(b,j,k);break;case"ean8":case"ean13":n=Barcode.ean.getDigit(b,k);f=Barcode.ean.compute(b,k);break;case"code11":n=Barcode.code11.getDigit(b);f=b;break;case"code39":n=Barcode.code39.getDigit(b);f=b;break;case"code93":n=Barcode.code93.getDigit(b,j);f=b;break;case"code128":n=Barcode.code128.getDigit(b);f=b;break;case"codabar":n=Barcode.codabar.getDigit(b);f=b;break;case"msi":n=Barcode.msi.getDigit(b,j);f=Barcode.msi.compute(b,j);break;case"datamatrix":n=Barcode.datamatrix.getDigit(b,m);f=b;h=true;break}if(n.length==0){return(l)}if(!h&&e.addQuietZone){n="0000000000"+n+"0000000000"}var c="digitTo"+e.output.charAt(0).toUpperCase()+e.output.substr(1)+(h?"2D":"");if(typeof(Barcode[c])=="function"){Barcode[c](l,e,n,f)}return(l)}};Element.addMethods("DIV",barcodeMethod);Element.addMethods("CANVAS",barcodeMethod);